// c:\tc\Email\ Swing.Cpp                            March 15, 1996

//       320 x 200 screen with 256 colors (Borland Document 1031)

void GrInit(void);
void GrClose(void);
void PP(unsigned int x, unsigned int y, unsigned char color);

#include <stdlib.h>
#include <dos.h>
#include <math.h>   	// abs(),labs()
#include <conio.h>	// getch()
#include <stdio.h>  	//stdout.
#include <iostream.h>	// cout <<
#include <fstream.h>
#include <time.h>
#include <io.h>		// access

int Anzahl;      // Number of available Game Runs
double sigma = 82904;
int step;
int del = 1; 		// assumes speed setting
int upper = 100;		// parameters for moving block
int lower = 110;
int width = 20;
int col = 0;	 	// color or color range
int attitude = 0,att; 	// 0,1,2,3 : alert, sleepy, hard-pushing, meditating
int goal = 1;		// 0,1 : Narrow/Wide
int Speed = 4;
int score;
int test = 0;
int jmp = 0;		// for jmp=1 jump selection page
int Del[] = {30,25,20,15,1,23,17,12,8,5};   // del = 4: about 15 sec run
char dat[] = "swingdat";   	//fptr
char datpsi[] = "swingdat.psi"; //fpdat
char druck[] = "prntswg.psi";   //fprint
char typus[] = "27496385sla-001/";//is updated and used as head of
prntswg.psi
FILE *fptr, *fpdat, *fprnt;

int hasfile;            // 1 if MoveDat.Psi exists, 0 else
unsigned int hasprint;  // 1 if printer connected, 0 else

int runsleft;           // Anzahl - unit
int unit;		// current run number 0,1,... Anzahl-1
unsigned long SdM, SdS; // 16-bit seeds
unsigned long RnS, RnM, RnS0, RnM0;
int Rn;
int assign;             // for critics assignment: not used
int rowOffset[200];
char pl[256][3];
unsigned char color,ch,ch0,cha;
int i,k,n,h,q;
long int j;
char List[12][20] = {"green             \0","yellow            \0",
		     "red               \0","blue              \0",
		     "light blue        \0","violet            \0",
		     "blue--red         \0","red--blue         \0",
		     "green--blue       \0","blue--green       \0",
		     "red--yellow--green\0","green--yellow--red\0"};

char ListA[5][16] = {"alert       \0","sleepy      \0",
		    "hard-pushing\0","meditating  \0","INCOMPLETE  \0"};
char game[]  = "Game";
char demo[]  = "Demo";
char Ito[17];  // for itoa
const long P = 524287;
const int PA = 79, PB = 3067;
char zeit[16];
int ofdat;
int zeig,zeig0,farbe;
const int n1 = 512; const n2 = 2*n1;
int C[2*n1],S[2*n1]; // cos, sin tables
int rfac = 500;
int z1,z2,z10,z20,k1,k2,d1,d2,d,cycles,cycle;
int y;
float Score,SScore;

void traceWait()		//wait for vertical retrace
{
trwait1:
  asm {
	mov 	dx,0x3DA
	in	al,dx
	and	al,8
	jnz	trwait1 }
trwait2:
  asm {
	mov 	dx,0x3DA
	in	al,dx
	and	al,8
	jz	trwait2 }
}

void getzeit()
    {	zeit[15] = '\0';
	struct tm *ptr;
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);
	for(int j=0;j<15;j++) zeit[j] = asctime(ptr)[j+4];
     }

int iszahl(unsigned char c0)		//  48..57  65..70 (ASCII)
   { int is1=1;                         //   0...9   A...F
     if(c0<48 || c0>70 || (c0<65 && c0>57)) is1=0;
     return is1;
   }

int Getc(FILE *fp)    // ignore non-hex-numbers
   { int gtc = 0, gt;
     while(gtc==0) { gt = getc(fp); gtc = iszahl(gt);}
     return gt;
   }

int makezahl(char ch)          // transform char 0,1,..,F into number
   { int anz = ((int)ch)-48;
     if (anz > 16) anz -=7;
     return anz;            }

unsigned int holint()
    {
	unsigned int uni = makezahl(getc(fpdat)); uni = uni <<4;
	uni += makezahl(getc(fpdat));
	return uni;
    }

unsigned int makehex(unsigned int xx) // ret.lowest 4 bits of xx as Ascii-Hex
    {  xx = xx & 15; xx += 48; if(xx>57) xx += 7; return xx; }

char makechar(int nn)         //     Number 0,1,...,15 -> char 0,...,F
   { nn += 48; if(nn > 57) nn += 7;
     return (char)nn;              }

int Get2Bits()
    {
       RnM = (RnM*PA) % P; RnM = (RnM*PB) % P;
       unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
       Rn = (RnS ^ RnM);
       if(assign==0) Rn =  Rn ^ 3;
       if(goal) Rn = Rn ^ 3;
       Rn = Rn & 3;
       return Rn;
    }

void Shift()
   {   unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
   }
/* Shift Register (17 bits):

	^ 16  15 14  ......  3   2   1   0
	|____________________|___________|

nextRn() repeats after about 2^36 = 68,000,000,000 = 68 billion steps,
with 2^32 = 4.29 billion entry points.
*/

void GrInit()
    {	for(i=0; i<200; i++) rowOffset[i]=i*320;
	_AH=0;_AL=0x13; geninterrupt(0x10);}

void GrClose()             	//set to 80*25 Color Text
     {	_AH=0; _AL=0x3; geninterrupt(0x10); }

void PP(int xx, int yy, int col)        // Plot Point
    {	*((char far *) 0xA0000000L + (xx+rowOffset[yy]))=col; }

void Setline(int ii,int col00)
      {	for(j=upper;j<lower;j++) PP(ii,j,col00);}

void Right(int ii,int col00)
  { for(int aa = zeig0+width+1;aa<zeig0+width+ii+1;aa++) Setline(aa,col00);
    for(aa = zeig0-width;aa<zeig0-width+ii;aa++) Setline(aa,0);      }

void Left(int ii,int col00)
  { for(int aa = zeig0-width-ii;aa<zeig0-width;aa++) Setline(aa,col00);
    for(aa = zeig0+width-ii+1;aa<zeig0+width+1;aa++) Setline(aa,0);       }

void SetAllColors(char (*pl)[3])
{
	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1012;
	_BX=0;
	_CX=16;		// max 256  works much faster for smaller values
	geninterrupt(0x10);
}

void GetAllColors(char (*pl)[3]) // loads standard colors to palette ?
{
	traceWait; //   doesn't do anything ??
	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1017;
	_BX=0;
	_CX=16;		// max 256
	geninterrupt(0x10);
}

void p(int jc,char* pt)  {gotoxy(1,jc); cputs(pt);}

void fout(long zz)    // cout << formatted number, 8 spaces
{  int kk= 8;
   long zzz = labs(zz);  // long abs
   while(zzz>0) {zzz = zzz/10; kk--;}
   if(zz<0) kk-- ;
   while(kk>0) { cout << " "; kk-- ;}
   cout << zz;
}
// .............................................................

void main()
{
for(k=0;k<2*n1;k++)
	  {  C[k] = (int) (rfac*cos((M_PI*k)/n1));
	     S[k] = (int) (rfac*sin((M_PI*k)/n1)); }
	    unsigned long Q = 0;
	    unsigned long lock = (9+16*(4+16*(7+2*16)));
	    lock = 6+16*lock;
	    lock = 3+16*lock;
	    lock = 8+16*lock;
	    lock = 5+16*lock;  // lock = HEX{27496385}

clrscr();
randomize();
test = 0;
hasfile = 0;      // Test if data file is present, set hasfile = 0/1
if(!access(datpsi,0)) hasfile=1;// needs io.h  (Compl.Refer.pg346)
			// access(. ,0) = 0 if file is present !
long ofdat = 0, ofin = 0;
int anf = 0, ende = 0;
//.................... generate file swingdat.psi if appropriate........
if(!hasfile && !access(dat,0))
  {      fpdat = fopen(datpsi,"wb");	//swingdat.psi
	 fptr  = fopen(dat,"rb+");       //swingdat
	 // needs BINARY file to make ftell(fpdat) work right
	 fprnt = fopen(druck,"w");      //prntswg.psi
	 fseek(fptr,ofin,0);
	 fseek(fpdat,ofdat,0);
     while(!feof(fptr) )
	    {  if(!feof(fptr)) {ch = getc(fptr); }
	      if(iszahl(ch)) { Q = Q<<4; Q += makezahl(ch);} else Q=0;
	      if(Q == lock) {ende=1;break;}
	    }
  if(ende)
   { ofin = ftell(fptr)-8; fseek(fptr,ofin,0);
		// sets file pos.indicater to start of code 274..
     for(i=0;i<16;i++){ch=getc(fptr);putc(ch,fpdat);typus[i]=ch;}
     for(i=0;i<2;i++) {ch=Getc(fptr);putc(ch,fpdat);}
     ch0 = '0'; for(i=0;i<2;i++) putc(ch0,fpdat);
     fprintf(fprnt,"%s",typus);  fclose(fprnt);
     i=0;
     while(!feof(fptr))
	    {  if(!feof(fptr)) ch = getc(fptr);
	       if(iszahl(ch))
		{i=(i+1)%8; putc(ch,fpdat);
		 if(i==0){putc(ch0,fpdat);putc(ch0,fpdat);}}
	    }
     // disable the file swingdat by changing the code 27496385 -> 07496..
     fseek(fptr,ofin,0); ch = '0'; putc(ch,fptr);
     fclose(fptr);fclose(fpdat);
     hasfile = 1;
   }
  }

if(hasfile)
{	fpdat = fopen(datpsi,"r+");
	int ofdat = 16; fseek(fpdat,ofdat,0);
	Anzahl = holint();
	unit = holint();
	runsleft = Anzahl - unit; // if full then unit = Anzahl
	if(runsleft)
	  { ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1;
			RnM0 = SdM | 0x300;
	   }
	 fclose(fpdat);
}

SdS = random(256);SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM | 0x0300;

//............... First Page at Power-Up ............................
clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(2,"                            Experiment:  SWING");
for(j=0;j<32;j++) {q = j % 8 + 8;textcolor(q);gotoxy(22+j,4);cputs(".");}
textcolor(11);
p(7,"                              Helmut Schmidt");
p(8,"                                P.O.Box 296");
p(9,"                              Mora, NM 87732");
p(10,"                              (505) 387-2184");
p(11,"                            psischmidt@aol.com");
textcolor(10);
p(15,"          See the File README for General Information on the
Experiments");
p(17,"          Read File Swing.Txt for Details on this Experiment SWING");
p(19,"             Turn the Printer on if you want a Printed record");
textcolor(11);
if(!hasfile)
{ p(21,"                    No Data Files: Only Explore-Runs are
available.");}
else {p(21,"                 Number of still Available Record-Runs :");
       gotoxy(60,21);cputs(itoa(runsleft,Ito,10));}
textcolor(14);
p(24," Press X to EXIT Program.                       Press any Key to
Continue");
ch0 = getch(); if(ch0=='X' || ch0=='x') exit(0);
//..................................................................

int rep=0;
randomize();
test = 0;
SdS = random(256);SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM + 0x0300;

Anfang:
if(jmp) goto Weiter;

Anfang1:
clrscr();
// for(int n=0;n<16;n++) {textcolor(n);gotoxy(n,2);cputs("X");}
textcolor(13);
p(1,"                      Program: Swing");
textcolor(10);
p(3,"A pendulum will swing with varying amplitudes. You want the swing to
be");
p(4,"either wide from side to side, or narrow, staying near the screen
center.");
textcolor(13);
p(6,"You may select the following options:");
textcolor(14);
p(8,"Select the Goal, Wide or Narrow Swing by pressing G. Goal :");
textcolor(13);gotoxy(54,8);cputs("G");textcolor(14);
p(10,"Select a speed by pressing 0,1,..4 (faster).        Speed :");
p(11,"If Speed 4 is too slow use 5,6,..9 (fastest).");
textcolor(13);gotoxy(28,10);cputs("0,1,..4");textcolor(14);
p(13,"Select between the informal Explore-Mode and the");
p(14,"Record-Mode with recorded results by  pressing M.     Mode:");
textcolor(13);gotoxy(55,14);cputs("M");textcolor(14);
p(16,"Select a color or color range by pressing C.         Color:");
textcolor(13);gotoxy(54,16);cputs("C");textcolor(14);
p(18,"You may approach the task with different mental");
p(19,"Attitudes. Select what fits best by pressing A.   Attitude:");
textcolor(13);gotoxy(51,19);cputs("A");
textcolor(13);
p(21,"Press ENTER to get the Start Display. Then Press ENTER again.");
textcolor(10);
p(22,"                    Press X to exit the program.");
textcolor(15);
p(23,"  An Explore-Run may be interrupted by pressing ENTER.");
p(24,"  A Record-Run cannot be interrupted.");
textcolor(10);
if(hasfile)
  { gotoxy(54,24);cputs("Record-Runs left:");
    gotoxy(72,24); cputs(itoa(runsleft,Ito,10));}
else{ gotoxy(54,24);cputs("Only Explore-Runs available");}
textcolor(13);
gotoxy(62,19);cputs(&ListA[attitude][0]);
gotoxy(62,16);cputs(&List[col][0]);
gotoxy(62,14); if(test) cputs("Record-Run "); else cputs("Explore-Run");
gotoxy(62,8); if(goal) cputs("Wide Swing   ");else cputs("Narrow Swing ");
gotoxy(62,10);cputs(itoa(Speed,Ito,10));

for(;;) {  while(!kbhit()) Shift(); ch = getch();
	   if(ch==13) break;	 // ENTER
	   if(ch=='X'||ch=='x') {GrClose(); exit(0);}
	   if(ch=='M'||ch=='m') test = 1-test;
	   if(ch=='G'||ch=='g') goal = 1 - goal;
	   if(ch=='C'||ch=='c') col++; col = col % 12;
	   if(ch=='A'||ch=='a') attitude++; attitude = attitude % 4;
	   if((ch>47) && (ch < 59)) Speed = ch - 48;
  gotoxy(62,19);cputs(&ListA[attitude][0]);
  gotoxy(62,16);cputs(&List[col][0]);
  gotoxy(62,14); if(test) cputs("Record-Run "); else cputs("Explore-Run");
  gotoxy(62,8); if(goal) cputs("Wide Swing   ");else cputs("Narrow Swing ");
  gotoxy(62,10);cputs(itoa(Speed,Ito,10));
	}
del = Del[Speed];

Weiter:
	GrClose();
	GrInit();
	GetAllColors(pl);
	pl[3][0]=40; pl[3][1]=40; pl[3][2]=40; // variable color
	pl[4][0]=0; pl[4][1]=63; pl[4][2]=0; //  green : first dot
	pl[5][0]=0; pl[5][1]=63; pl[5][2]=63; //        <      "
	pl[6][0]=63;pl[6][1]=63; pl[6][2]=63;// color6 = white
	pl[8][0]=20; pl[8][1]=20 ; pl[8][2]=63; // blue
	pl[9][0]=63 ; pl[9][1]=20; pl[9][2]=0; // red
	pl[10][0]=0 ; pl[10][1]=63 ; pl[10][2]=0;// green
	pl[11][0]=0 ; pl[11][1]=0 ; pl[11][2]=0; //center target color
	pl[7][0]=60; pl[7][1]=43; pl[7][2]=0; // yellow-gold text <<---

	long int B = 16;// Define colors
	for(j=0;j<16;j++){pl[B+j][0]=60;pl[B+j][1]=4*j;pl[B+j][2]=0;}
	B=32;for(j=0;j<16;j++){pl[B+j][0]=60-4*j;pl[B+j][1]=60;pl[B+j][2]=0;}
	B=48;for(j=0;j<16;j++){pl[B+j][0]=0;pl[B+j][1]=60;pl[B+j][2]=4*j;}
	B=64;for(j=0;j<16;j++){pl[B+j][0]=0;pl[B+j][1]=60-4*j;pl[B+j][2]=60;}
	B=80;for(j=0;j<16;j++){pl[B+j][0]=4*j;pl[B+j][1]=0;pl[B+j][2]=60;}
	B=96;for(j=0;j<16;j++){pl[B+j][0]=60;pl[B+j][1]=0;pl[B+j][2]=60-4*j;}
	B=112;for(j=0;j<16;j++){pl[B+j][0]=60;pl[B+j][1]=4*j;pl[B+j][2]=0;}
	B=128;for(j=0;j<16;j++){pl[B+j][0]=60-4*j;pl[B+j][1]=60;pl[B+j][2]=0;}

	SetAllColors(pl);

struct tm *ptr;			// print data and time
time_t lt;
lt = time(NULL);
ptr = localtime(&lt);

zeig = 160;
farbe=3;
for(i=zeig-width;i<(zeig+width+1);i++)   // draw rectangle
{ for(j=upper;j<lower;j++)
      {  PP(i,j,farbe);}
}
SetAllColors(pl);

for(j=0;j<18;j++) cout << endl;
if(rep) goto Loop2;
if(goal) cout << "Aim for Wide Swing Amplitude";
else cout << "Hold Rectangle Near Center: Narrow Swing";
cout << endl << endl;
cout << "Press ENTER to Start" << endl<<endl;
cout << "Press X to Abort" ;
rep = 1;
Loop1:
while(!kbhit()) Shift(); ch = getch();
if(ch=='x'||ch=='X') {GrClose();goto Anfang1;}
goto Weiter;
Loop2:

// ..................Start Run Display ............................

PP(160,178,5);PP(160,182,5); // center marker
delay(500);
cycles=64; // 64 for 1/2 min
Score = 0;
k1=0,k2=n1/2;
int b1=3,b2=3;

if(!runsleft) test = 0;
int zeig = 0;
if(test) {RnS=RnS0;RnM=RnM0;}
int cut=0; // set 1 if run is interrupted
for(cycle=0;cycle<cycles;cycle++)
{ int rr = Get2Bits();
  b1 += 2*(rr & 1)-1;if(b1==7) b1=6; if(b1==-1) b1=0;
  b2 += (rr & 2)-1;if(b2==7) b2=6; if(b2==-1) b2=0;
  d1 = 8 + b1;
  d2 = 8 + b2;
   for(step=0;step<32;step++) // 100 looks good
      {
	y = S[k1]+S[k2];
		z1 = 160 + S[k1]/5;
		z2 = 160 + S[k2]/5;
	k1 = (k1+d1) % n2;
	k2 = (k2+d2) % n2;
	zeig0 = zeig;
	zeig = 160 + y/8;
	d = zeig - zeig0;
	int a = abs(k1-k2); if(a>512) a = 1024-a; Score += (256-a);

/* Color Range  j = 32 yellow (60,60, 0)
		    48 green  ( 0,60, 0)
		    64 skyblu ( 0,60,60)
		    80 blue   ( 0,0 ,60)
		    96 violet (60, 0,60)
		   112 red    (60, 0, 0)
		   128 yellow (60,60, 0)
		   143 green  ( 0,60, 0)
*/
switch(col)
{
case 0:    j = 48; break;			// green
case 1:	   j = 32; break;			// yellow
case 2:	   j = 112;break;			// red
case 3:	   j = 80; break;			// blue
case 4:	   j = 64; break;			// light-blue
case 5:	   j = 96; break;			// violet
case 6:	   j = 80 + (512-a)/16;break;		// blue--red
case 7:	   j = 112 + (a-512)/16;break; 		// red--blue
case 8:	   j = 48 + (512-a)/16;	break;		// green--blue
case 9:	   j = 80 + (a-512)/16;	break;		// blue--green
case 10:   j = 112 + (512-a)/16;break;		// red--yellow--green
case 11:   j = 143 + (a-512)/16;break;		// green--yellow--red
}
	     for(k=0;k<3;k++) pl[3][k]=pl[j][k];
	if(Speed < 5) traceWait();
	if(d>0) Right(d,farbe);
	if(d<0) Left(-d,farbe);
	PP(z10,20,0);   PP(z20,30,0);
	PP(z1,20,6);PP(z2,30,6);
	PP(160+SScore/1000,180,0);PP(160+Score/1000,180,5);
		z10 = z1;
		z20 = z2;
		SScore = Score;
	if(kbhit()) {cycle = cycles;cut=1;}
	delay(Del[Speed]);
	SetAllColors(pl);
      }
  }
rep = 0;
 if(cut) {GrClose(); getch();goto Anfang1;}
 if(goal==0) Score = -Score;
score = (int) (100*Score/sigma);
delay(500);
GrClose();GrInit();SetAllColors(pl);
cout<< endl;
cout << "Score = " << score << endl;
cout << "----------- " <<  endl << endl << endl;
cout << "    For Same Run press the Space Bar" << endl << endl;
cout << "    For New Run press ENTER" << endl<< endl;
cout << "    To EXIT Program press X";

getzeit();

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer
if(goal) cha='H'; else cha='L';

	if(test)
	     {  unit++; runsleft = Anzahl - unit;
		fpdat = fopen(datpsi,"r+");
		ofdat = 18; fseek(fpdat,ofdat,0);      // new unit
		i = unit >> 4;
		ch = makehex(i); putc(ch,fpdat);
		ch = makehex(unit); putc(ch,fpdat);

		ofdat = 20+10*unit-2;    	// write info-byte
		fseek(fpdat,ofdat,0);
		i = 1 + Speed + 16*(attitude + 8*goal);
		j = i >> 4;
		ch = makehex(j); putc(ch,fpdat);
		ch = makehex(i); putc(ch,fpdat);

		if(unit<Anzahl)
		{
		ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1; // SdM.0 for optional later assignment
		 }	RnM0 = SdM | 0x0300;
		 fclose(fpdat);
	    }

if(test)
   {	fprnt = fopen(druck,"a"); // open for append text
	fprintf(fprnt,"\n\r%s%4d,%s%c,%s%2d,%s%s%s",
	"Score =",score," Aim: ",cha," Speed:",Speed ,
		 ListA[attitude],",",zeit);
	fprintf(fprnt,"%s%3d","  Sla# ",unit-1);
	fclose(fprnt);
    }

if(hasprint)
{
	fprintf(stdprn,"\n\r%s%4d,%s%c,%s%2d,%s%s%s%s",
	"Score =",score," Aim: ",cha," Speed:",Speed ,
				   ListA[attitude],",",zeit," Swg# ");
	if(test) fprintf(stdprn,"%2d",unit-1);
}

if(kbhit())getch();
ch = getch();
GrClose();
if(ch==13) { jmp = 0; goto Anfang;}
if(ch==32) { jmp = 1; goto Anfang;}
}

