// c:\tc\Email\Crash.Cpp                               Final form 4/1/96
/*
   Two alternating aims:
a) Swing with maximal amplitude around trees. Go as long as possible
   (average 20 trees) without hitting tree.
b) Try to hit a tree as fast as possible

   Input Data File:  crashdat gets converted into crashdat.psi
   Output Data File: prntcras.psi  holds scores,times etc of TEST RUNS
   Convenient display of all Test Runs and recent Play Runs.

   Expectation and sigma calculated with CrashMat.Cpp
*/

#include <conio.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <timer.h>
#include <math.h>
#include <stdlib.h>  // randomize
#include <graphics.h>
#include <iostream.h>
#include <fstream.h>
#include <io.h>			// access
#define SETMODE 0
#define VIDEO 0x10
#define MAXR 200		// rows
#define MAXC 320		// columns
#define MAXB (MAXC/8)		// bytes in a row
#define ob outportb

int Anzahl, unit;
char zeit[16], Ito[17];
int i,j,k,l,q,high;
unsigned char ch,ch0,cha;
int ampstart=4, maxamp=4; // exp = 19.95, sig = 15.91
float S[128];
int T[128][7];
float xx,yy,zz,zf;
char far *farptr;
int row, col,x,y,z,z1,z2,M0,M1,s;
int b[] = {128,64,32,16,8,4,2,1};
unsigned char color;
int addr,A,score,speed=4,test=0;  // test = 0/1 for Play/Test
int gdriver, gmode,mode;

char dat[] = "crashdat";   	//fptr
char datpsi[] = "crashdat.psi"; //fpdat
char druck[] = "prntcras.psi";   //fprint
char typus[] = "27496385crs-001/";//is updated and used as head of
prntswg.psi
FILE *fptr, *fpdat, *fprnt;

char chp[17]; // for itoa
char tst1[] = {"Record-Run"};
char tst0[] = {"Explore-Run"};
char tst2[] = {"Explore-Runs Only"};
char* tst = tst0;
int fast = 0;  // set fast = 1 for speedup
int spd[] = {16,8,4,2,0,16,8,4,2,0};
int playsc[20],playsc2[20],testsc[100];
//char dat[322];  // read from file slaldat
long int P = 524287; // prime 2^19 - 1
int PA = 79, PB = 3067, Sh;
long int SeedM[100], SeedS[100], Rn, RnM, RnS, SdS, SdM;
int hasfile = 1, runsleft,hasprint;
int eps = 1; // aim for demo runs
int pzeiger, pcount, aim;
// ...................................................................

void getzeit()
     {                         // Enters current time into zeit[15]
	zeit[15] = '\0';
	struct tm *ptr;
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);
	for(int j=0;j<15;j++) zeit[j] = asctime(ptr)[j+4];
     }

void p(int jc,char* pt)
   {gotoxy(1,jc); cputs(pt);}

int iszahl(unsigned char c0)		//  48..57  65..70 (ASCII)
   { int is1=1;                         //   0...9   A...F
     if(c0<48 || c0>70 || (c0<65 && c0>57)) is1=0;
     return is1;
   }

int Getc(FILE *fp)    // ignore non-hex-numbers
   { int gtc = 0, gt;
     while(gtc==0) { gt = getc(fp); gtc = iszahl(gt);}
     return gt;
   }

int GetBit()
    {
       RnM = (RnM*PA) % P; RnM = (RnM*PB) % P;
       unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
       Rn = (RnS ^ RnM) & 1;		// need only binary decision
       return Rn;
    }

void Shift()
   {   unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
   }

int TotScore(int ii)
{       int sci=0,ampi=4,maxi=4;
	RnS = (SeedS[ii]<<1)+1;
	RnM = 0x301 | SeedM[ii];
	GetBit();
	while(ampi)
	{ ampi += (2*GetBit()-1);
	  if(ampi>maxi) ampi=maxi;
	  sci++;
	 }
	 return sci;
}

int makezahl(char ch)          // transform char 0,1,..,F into number
   { int anz = ((int)ch)-48;
     if (anz > 16) anz -=7;
     return anz;            }

char makechar(int nn)         //     Number 0,1,...,15 -> char 0,...,F
   { nn += 48; if(nn > 57) nn += 7;
     return (char)nn;              }

unsigned int holint()
    {
	unsigned int uni = makezahl(getc(fpdat)); uni = uni <<4;
	uni += makezahl(getc(fpdat));
	return uni;
    }

unsigned int makehex(unsigned int xx) // ret.lowest 4 bits of xx as Ascii-Hex
    {  xx = xx & 15; xx += 48; if(xx>57) xx += 7; return xx; }

void AllScroll()
{
ob(0x3c4,2);   //	select MAP MASK Register: vital for scroll
ob(0x3c5,0xf); //	activate all planes:else only some colors scroll ?
ob(0x3ce,5); // select MODE Register
ob(0x3cf,1); // set MODE 1
*(farptr+8000) = *(farptr+2540+80*fast); //2540=63*40+20  8000 outside screen
for(j=63;j>0;j--)  *(farptr+j*40+20) = *(farptr+j*40-20-40*fast);
*(farptr+20) = *(farptr+8000);
if(fast) *(farptr+60) = *(farptr+8000);

for(register line=199;line>(63- fast);line--)
   {	for(register add=6;add<34;add++)
	{ M0 = line*MAXB; M1 = (line-1- fast)*MAXB;
	 *(farptr+add+M0) = *(farptr+add+M1); }
   }
ob(0x3ce,5);
ob(0x3cf,0); //set write mode 0
if(spd[speed]>0) delay(spd[speed]);
}

void Rein(int x0)
      {	y = T[x0][A]/8; z = T[x0][A] % 8;
	*(farptr+y+MAXB*(64+4*fast)) = b[z]; }

void PN(int zx)  // print integer number in color text mode
	{cputs(itoa(zx,chp,10));}

void Settree()
   {	for(addr=0;addr<MAXB*MAXC;addr++) *(farptr+addr)=0;// clear all
	color = 10;
	ob(0x3C4,2);	  // set color to write
	ob(0x3C5,color);     //   into map mask register
	//for(j=0;j<8;j++) *(farptr+20+40*(j+26))=0xFF;
	j=0; *(farptr+20+40*(j+26))= 0x3c;
	j=1; *(farptr+20+40*(j+26))= 0x7e;
	j=2; *(farptr+20+40*(j+26))= 0xff;
	j=3; *(farptr+20+40*(j+26))= 0xff;
	j=4; *(farptr+20+40*(j+26))= 0xff;
	j=5; *(farptr+20+40*(j+26))= 0xff;
	j=6; *(farptr+20+40*(j+26))= 0x7e;
	j=7; *(farptr+20+40*(j+26))= 0x3c;
   }
// .....................................................................

void main()
{
//			I am using my extended Graphics.Lib to get
//                      a stand-alone program with the next two lines

if (registerbgidriver(EGAVGA_driver) < 0) exit(1);
if (registerbgifont(sansserif_font) < 0) exit(1);

randomize();
SdS = random(256);SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM | 0x0300;

//                                               Next generate sine Tables
for(x=0;x<64;x++)
  { zf = sin(x*2*M_PI/128.0);S[x]= zf; S[x+64] = -zf;}
for(x=0;x<128;x++) T[x][4] = 164 + (int)  95*sin(x*M_PI/64.0);// 70
for(x=0;x<128;x++) T[x][3] = 164 + (int)  65*sin(x*M_PI/64.0);// 55
for(x=0;x<128;x++) T[x][2] = 164 + (int)  40*sin(x*M_PI/64.0);// 30
for(x=0;x<128;x++) T[x][1] = 164 + (int)  15*sin(x*M_PI/64.0);// 15
for(x=0;x<128;x++) T[x][0] = 164 + (int)   3*sin(x*M_PI/64.0);// 3
speed = 4; //...........................................temp

for(j=0;j<20;j++) playsc[j] = 0;
for(j=0;j<100;j++) testsc[j] = 0;

	    unsigned long Q = 0;
	    unsigned long lock = (9+16*(4+16*(7+2*16)));
	    lock = 6+16*lock;
	    lock = 3+16*lock;
	    lock = 8+16*lock;
	    lock = 5+16*lock;  // lock = HEX{27496385}

clrscr();
randomize();
test = 0;

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer
if(hasprint)  fprintf(stdprn,"\n\r");

hasfile = 0;      // Test if data file is present, set hasfile = 0/1
if(!access(datpsi,0)) hasfile=1;// needs io.h  (Compl.Refer.pg346)
			// access(. ,0) = 0 if file is present !
long ofdat = 0, ofin = 0;
int anf = 0, ende = 0;
//.................... generate file movedat.psi if appropriate........
if(!hasfile && !access(dat,0))
  {      fpdat = fopen(datpsi,"wb");	//crashdat.psi
	 fptr  = fopen(dat,"rb+");       //crashdat
	 // needs BINARY file to make ftell(fpdat) work right
	 fprnt = fopen(druck,"w");
	 fseek(fptr,ofin,0);
	 fseek(fpdat,ofdat,0);
     while(!feof(fptr) )
	    {  if(!feof(fptr)) {ch = getc(fptr); }
	      if(iszahl(ch)) { Q = Q<<4; Q += makezahl(ch);} else Q=0;
	      if(Q == lock) {ende=1;break;}
	    }
  if(ende)
   { ofin = ftell(fptr)-8; fseek(fptr,ofin,0);
		// sets file pos.indicater to start of code 274..
     for(i=0;i<16;i++){ch=getc(fptr);putc(ch,fpdat);typus[i]=ch;}
     for(i=0;i<2;i++) {ch=Getc(fptr);putc(ch,fpdat);}
     ch0 = '0'; for(i=0;i<2;i++) putc(ch0,fpdat);
     fprintf(fprnt,"%s",typus);  fclose(fprnt);
     i=0;
     while(!feof(fptr))
	    {  if(!feof(fptr)) ch = getc(fptr);
	       if(iszahl(ch))
		{i=(i+1)%8; putc(ch,fpdat);
		 if(i==0){putc(ch0,fpdat);putc(ch0,fpdat);}}
	    }
//     disable the file crashdat by changing the code 27496385 -> 07496..
     fseek(fptr,ofin,0); ch = '0'; putc(ch,fptr);
     fclose(fptr);fclose(fpdat);
     hasfile = 1;
   }
  }

if(hasfile)
{	fpdat = fopen(datpsi,"r+");
	int ofdat = 16; fseek(fpdat,ofdat,0);
	Anzahl = holint();
	unit = holint();
	runsleft = Anzahl - unit; // if full then unit = Anzahl
  for(int uni=0;uni<Anzahl;uni++)
	  { ofdat = 20+ 10*uni; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			SeedS[uni] = SdS;
			SeedM[uni] = SdM;
	   }
	 fclose(fpdat);
}
for(j=0;j<unit;j++) testsc[j]=TotScore(j);

//............... First Page at Power-Up ............................
clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(2,"                            Experiment:  CRASH");
for(j=0;j<32;j++) {q = j % 8 + 8;textcolor(q);gotoxy(22+j,4);cputs(".");}
textcolor(11);
p(7,"                              Helmut Schmidt");
p(8,"                                P.O.Box 296");
p(9,"                              Mora, NM 87732");
p(10,"                              (505) 387-2184");
p(11,"                            psischmidt@aol.com");
textcolor(10);
p(15,"          See the File README for General Information on the
Experiments");
p(17,"          Read File Crash.Txt for Details on this Experiment CRASH");
p(19,"               Turn the Printer on if you want a Printed Record");
textcolor(11);
if(!hasfile)
{ p(20,"                    No Data Files: Only Explore-Runs are
available.");}
else { p(21,"                 Number of still Available Record-Runs :");
       gotoxy(60,21);cputs(itoa(runsleft,Ito,10));}
textcolor(14);
p(24," Press X to EXIT Program.                       Press any Key to
Continue");
while(!kbhit()) Shift();
ch0 = getch(); if(ch0=='X' || ch0=='x') exit(0);

clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(1,"                       Crash-Experiment");
textcolor(15);
p(3,"   You will see a trace curving around a row of obstacles. You might");
p(4,"imagine yourself, or your opponent, in the role of a skier slaloming");
p(5,"around a row of trees.");
textcolor(11);
p(7,"In the successive games, you have two alternating goals:");
textcolor(14);
p(9,"   In one case, you want to keep far away from the trees, trying to
get");
p(10,"around as many trees as possible. When you finally hit a tree, a
score");
p(11,"is displayed that measures the number of safely negotiated trees.");
p(12,"Thus you are aiming for a HIGH score. Approach this goal with a");
p(13,"relaxed, positive, high-spirited attitude.");
textcolor(10);
p(15,"   In the other case, you want to make your opponent hit a tree as
fast");
p(16,"as possible. You are aiming for a LOW score. In this case, try a ");
p(17,"different attitude: Try to get mentally and physically tense, nearly");
p(18,"desperate, in the effort to guide the opponent to an early crash.");
textcolor(15);
p(20,"   The program allows for 'Explore-Runs' with scores saved only
until");
p(21,"the computer is turned off, and for Record-Runs'");
p(22,"with permanently saved scores.");
textcolor(11);
p(24,"                                        Press any key to continue");
while(!kbhit()) Shift(); getch();

//......................................................................

Setdat:
closegraph();  // needed to cancel repeated initgraph()
gdriver = VGA; gmode = VGAMED;  // screen 640 x 350
initgraph(&gdriver, &gmode," ");
//for(j=1;j<16;j++)
//{setcolor(j);outtextxy(10*j,170,"X");}
setcolor(14);
setbkcolor(0);
settextstyle(3,0,2);
outtextxy(10,10,"Steps = ");outtextxy(110,10,itoa(score,chp,10));
outtextxy(170,10,"   [Average = 20, Sigma = 16]");
settextstyle(3,0,1);
setcolor(10);
outtextxy(50,50,"To Start the Next Run press ............................
 Enter");
outtextxy(50,80,"To Exchange Explore and Record Run press ........ E");
outtextxy(50,110,"For full Score Display press
............................... S");
outtextxy(50,140,"To Exit Program press
...................................... X");
settextstyle(0,0,0);
outtextxy(80,295,"Try lower speed range 0,1,2,3,4 first [4 = fastest].");
outtextxy(80,304,"For slow computers use range 5,6,7,8,9 [9 = fastest].");
setcolor(13);
outtextxy(100,329,"Number of still available Record-Runs :");
outtextxy(430,329,itoa(runsleft,chp,10));
settextstyle(3,0,1);
NewSpeed:
settextstyle(3,0,1);
setcolor(14);
outtextxy(10,190,"Type of Run :");outtextxy(310,190,tst);
outtextxy(10,220,"The current speed setting is :");
setcolor(14);
outtextxy(310,220,itoa(speed,chp,10));
setcolor(10);
outtextxy(50,260,"To change speed (number 0,1,..9) type the number.");
while(!kbhit()) Shift();// keep quasi RNG operating
j = getch();
if((j>47) && (j<58))
	{setcolor(0);outtextxy(310,220,itoa(speed,chp,10));
	speed =j-48; fast=0; if (speed>4) fast=1;goto NewSpeed;}
j &= 0xdf;
if(j==69) {test = (1-test)*hasfile*(unit<100); // DEMO if no File or Full
	   setcolor(0); outtextxy(310,190,tst);
	   if(test) tst = tst1; else tst = tst0;
	   if(!(hasfile && (unit<Anzahl))) tst = tst2;
	   outtextxy(310,190,tst); goto NewSpeed; }
if(j==83) goto ScoreDisplay;           // for S choice
if(j==13) { goto Anfang;}
if(j!=88) goto NewSpeed;            // Exit for E choice
closegraph(); exit(0);


//                             Test Display Screen shows first one Tree.
//                             At ENTER the Run starts: Scrolling Screen.
Anfang:
if(unit>(Anzahl-1)) test = 0;

cleardevice();
setbkcolor(0);
if(test) { high = unit % 2;}
else { eps = 1-eps; high = eps;}
high = 1 - high; // start with high assignment
if(high)
{
setcolor(13);
outtextxy(10,80,"  A i m   f o r   L o n g   R u n   =   H i g h   S c o r
e");
outtextxy(20,140,"          K e e p   A w a y   f r o m   T r e e s");
}
else
{
setcolor(11);
outtextxy(10,80,"  A i m   f o r   S h o r t   R u n   =   L o w   S c o r
e");
outtextxy(10,140,"        T r y   t o   H i t   a   T r e e   F a s t");
}
//for(j=0;j<15;j++){setcolor(j);outtextxy(2,10*j,"X");}
setcolor(10);
if(test) outtextxy(200,200,"R e c o r d - R u n");
else outtextxy(200,200,"E x p l o r e - R u n");
setcolor(7);
outtextxy(1,300,"Press X to EXIT");
outtextxy(250,300,"Press any other Key twice to Start Run");
while(!kbhit()) Shift(); ch =getch();
if(ch=='x'||ch=='X') goto Setdat;
union REGS regs;
mode = 13;                    // Mode 13: 320 x 200 Screen
regs.h.al = (char) mode;
regs.h.ah = SETMODE;
int86(VIDEO,&regs,&regs);
farptr = (char far*) 0xA0000000;   // set ptr to EGA memory
ob(0x3ec,5);
ob(0x3ed,0); // mode 0
Settree();
if(!kbhit()) Shift(); getch();//delay(1000);
//................................................................

//                                                   Run Starts at ENTER
if(test){RnS = (SeedS[unit]<<1 ) + 1; RnM = 0x301 | SeedM[unit];}
GetBit();
A = ampstart ;score = 0;
s=1;
for(;;)
{ s = 1-s;
  for(k=0;k<64;k=k+1+fast)
     {                                             //   Start Half-Cycle
	ob(0x3C4,2);	  // set color to write
	ob(0x3C5,13);     //   into map mask register
	x = k % 128;
	Rein(x+64*s);
	AllScroll();
     }
     if(A==0) break;
     A += (2*GetBit() -1);
     if(A>maxamp) A=maxamp;
     score++;
     gotoxy(1,1);cout << score;//                 Running Score Display
     if(kbhit()) {j=getch();if((j>47)&&(j<58)) speed = j-48;}
}

  // RESET VIDEO, Waite II, pg 452  : doesn't help
 ob(0x3CE,5);
 ob(0x3CF,0);

if(fast && speed<5) speed +=5;
if(!fast && speed>4) speed -=5;

sound(300);               //                       End-of-Run  Tone Signal
delay(20);
nosound();
if(test)
     { testsc[unit] = score;}

else  { playsc[pzeiger] = score; pzeiger++; pcount++;
	if(pzeiger>20) {for(j=0;j<19;j++) playsc[j]=playsc[j+1];pzeiger=20;}
      }

getzeit();

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer
if(high) cha='H'; else cha='L';

	if(test)
	     {  unit++;runsleft = Anzahl - unit;
		fpdat = fopen(datpsi,"r+");
		ofdat = 18; fseek(fpdat,ofdat,0);      // new unit
		i = unit >> 4;
		ch = makehex(i); putc(ch,fpdat);
		ch = makehex(unit); putc(ch,fpdat);
		ofdat = 20+10*unit-2;    	// write info-byte
		fseek(fpdat,ofdat,0);
		i = 1 + speed + 16*high; // high = 1/0 for hi/lo aim
		j = i >> 4;
		ch = makehex(j); putc(ch,fpdat);
		ch = makehex(i); putc(ch,fpdat);
		fclose(fpdat);
		fprnt = fopen(druck,"a"); // open for append text
		fprintf(fprnt,"\n\r%s%4d,%s%c,%s%2d,%s%s%s",
		"Steps =",score," Aim: ",cha," Speed:",speed ,
				   ".....",",",zeit);
		fprintf(fprnt,"%s%2d"," Cra# ",unit-1);
		fclose(fprnt);
	   }

if(hasprint)
{
	fprintf(stdprn,"\n\r%s%4d,%s%c,%s%2d,%s%s%s%s",
    "Steps =",score," Aim: ",cha," Speed:",speed ,".....",",",zeit,"Cra# ");
	if(test) fprintf(stdprn,"%2d",unit-1);
}

goto Setdat;
// .....................................................................

//                                            Optional Full Score Display

ScoreDisplay:
closegraph();// use text mode with colors
clrscr();
textcolor(13);
gotoxy(8,1);cputs("Scores in the last 20 Explore-Runs and in all
Record-Runs.");
gotoxy(1,4);cputs("Explore-Runs : (Results arer lost at Exit).");
k=z1=z2=0;
for(j=0;j<20;j++)
   { if(j%2==0) z1 += playsc[j];else z2 +=playsc[j];
     if(playsc[j]>0) k++;}
j = (k+1)/2; if(j==0) j=1; z1 = z1/j;
j = k/2; if(j==0) j=1; z2 = z2/j;
textcolor(10);
gotoxy(60,5);PN(k);gotoxy(63,5);cputs("Explore-Runs");
gotoxy(63,7);cputs("Average ");
gotoxy(58,8);cputs("High-Aim  Low-Aim");
gotoxy(61,9); PN(z1); gotoxy(70,9);PN(z2);
for(j=0;j<20;j++) playsc2[j] = 0;k=0;
for(j=0;j<20;j++)
if(playsc[j]>0) {playsc2[k] = playsc[j]; k++;}

for(j=0;j<10;j++) {gotoxy(4+4*j,6);PN(playsc2[j]);}
for(j=0;j<10;j++) {gotoxy(4+4*j,7); PN(playsc2[j+10]);}
textcolor(13);
if(hasfile)
{
gotoxy(1,10);cputs("Record-Runs : (Results are permanently saved.)");
textcolor(10);
k=z1=z2=0;
for(j=0;j<80;j++)
   { if(j%2) z1 += testsc[j]; else z2 += testsc[j];
     if(testsc[j]>0) k++;}
j = (k+1)/2; if(j==0) j=1; z2 = z2/j;
j = k/2; if(j==0) j=1; z1 = z1/j;
   gotoxy(60,13);PN(k);gotoxy(63,13);cputs("Record-Runs");
   gotoxy(63,15);cputs("Average ");
   gotoxy(58,16);cputs("High-Aim  Low-Aim");
   gotoxy(61,17); PN(z2); gotoxy(70,17); PN(z1);

for(int kk=0;kk<8;kk++)
  { for(int jj=0;jj<10;jj++)
    {gotoxy(4+4*jj,12+kk);PN(testsc[jj+10*kk]);} }
}
else {gotoxy(10,15);cputs("No Data File: No Record-Runs Available");};
// for(j=1;j<16;j++) {gotoxy(2*j,23);textcolor(j);cputs("XX");}
textcolor(14);
gotoxy(4,24);cputs("You can save the data via PrintScreen");
textcolor(3);
gotoxy(50,25); cputs("Press any key to continue");
getch();
closegraph();
goto Setdat;
}

