// c:\tc\Email\ Move.Cpp                            12.3.1996

//       320 x 200 screen with 256 colors (Borland Document 1031)

void GrInit(void);
void GrClose(void);
void PP(unsigned int x, unsigned int y, unsigned char color);

#include <stdlib.h>
#include <dos.h>
#include <math.h>   	// abs(),labs()
#include <conio.h>	// getch()
#include <stdio.h>  	//stdout.
#include <iostream.h>	// cout <<
#include <fstream.h>
#include <time.h>
#include <io.h>		// access

int Anzahl;      // Number of available Game Runs
int Steps = 400;	// Number of binary decisions per run
double sigma = 4628;	// must be changes if Steps is changed
int step,step0;		// step0 = 1 if demo-run interrupted
int del = 1; 		// assumes speed setting
int upper = 40;		// parameters for moving block
int lower = 80;
int width = 40;
int col = 0;		// 0,1,2 : Colors red-green, green-blue, blue-red
int attitude = 0,att; 	// 0,1,2,3 : alert, sleepy, hard-pushing, meditating
int goal = 0;		// 0,1 : Right, Left
int Speed = 5;
int test = 0;
int jmp = 0,rep;		// for jmp=1 jump selection page
unsigned int ScoreR,ScoreL;
int Del[] = {32,24,20,16,12,8,6,4,2,1};     // del = 4 gives 15 sec run
FILE *fptr, *fpdat, *fprnt;
char dat[] = "move-dat"; // fptr
char datpsi[] = "move-dat.psi"; //fpdat
char druck[] = "prntmove.psi"; // fprnt
char typus[] = "27496385mov-001/";
int hasfile;            // 1 if MoveDat.Psi exists, 0 else
unsigned int hasprint;  // 1 if printer connected, 0 else

int runsleft;           // Anzahl - unit
int unit;		// current run number 0,1,... Anzahl-1
unsigned long SdM, SdS; // 16-bit seeds
unsigned long RnS, RnM, RnS0, RnM0;
int Rn;
int assign;             // for critics assignment: not used
int rowOffset[200];
char pl[256][3];
unsigned char color,ch,ch0;
int i,k,n,h,q;
long int j;
char List[3][14] = {"red-green \0","green-blue\0","blue-red  \0"};
char ListA[5][16] = {"alert       \0","sleepy      \0",
		    "hard-pushing\0","meditating  \0","INCOMPLETE  \0"};
char game[]  = "Game";
char demo[]  = "Demo";
char Ito[17];  // for itoa
int score;
const long P = 524287;
const int PA = 79, PB = 3067;
char zeit[16];
int ofdat;
int zeiger;

void traceWait()		//wait for vertical retrace
{
trwait1:
  asm {
	mov 	dx,0x3DA
	in	al,dx
	and	al,8
	jnz	trwait1 }
trwait2:
  asm {
	mov 	dx,0x3DA
	in	al,dx
	and	al,8
	jz	trwait2 }
}

void getzeit()
    {	zeit[15] = '\0';
	struct tm *ptr;
	time_t lt;
	lt = time(NULL);
	ptr = localtime(&lt);
	for(int j=0;j<15;j++) zeit[j] = asctime(ptr)[j+4];
     }


int GetBit()
    {
       RnM = (RnM*PA) % P; RnM = (RnM*PB) % P;
       unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
       Rn = (RnS ^ RnM) & 1;		// need only binary decision
       if(goal) Rn = 1 - Rn;
       if(assign==0) Rn = 1 - Rn;
       return Rn;
    }

void Shift()
   {   unsigned int hold1 = (RnS & 1) << 3;
       hold1 = (RnS & 8) ^ hold1;
       RnS = RnS >> 1;
       if(hold1 & 8) RnS = RnS | 0x100;
   }
/* Shift Register (17 bits):

	^ 16  15 14  ......  3   2   1   0
	|____________________|___________|

nextRn() repeats after about 2^36 = 68,000,000,000 = 68 billion steps,
with 2^32 = 4.29 billion entry points.
*/


int iszahl(unsigned char c0)		//  48..57  65..70 (ASCII)
   { int is1=1;                         //   0...9   A...F
     if(c0<48 || c0>70 || (c0<65 && c0>57)) is1=0;
     return is1;
   }

int Getc(FILE *fp)    // ignore non-hex-numbers
   { int gtc = 0, gt;
     while(gtc==0) { gt = getc(fp); gtc = iszahl(gt);}
     return gt;
   }

int makezahl(unsigned char chx)          // transform char 0,1,..,F into
number
   {
     int anz = chx-48;
     if (anz > 16) anz -=7;
     return anz;            }


unsigned int holint()
    {
	unsigned int uni = makezahl(getc(fpdat)); uni = uni <<4;
	uni += makezahl(getc(fpdat));
	return uni;
    }

unsigned int makehex(unsigned int xx) // ret.lowest 4 bits of xx as Ascii-Hex
    {  xx = xx & 15; xx += 48; if(xx>57) xx += 7; return xx; }



void GrInit()
    {	for(i=0; i<200; i++) rowOffset[i]=i*320;
	_AH=0;_AL=0x13; geninterrupt(0x10);}

void GrClose()             	//set to 80*25 Color Text
     {	_AH=0; _AL=0x3; geninterrupt(0x10); }

void PP(int xx, int yy, int col)        // Plot Point
    {	*((char far *) 0xA0000000L + (xx+rowOffset[yy]))=col; }

void Setline(int ii)
      {	for(j=upper;j<lower;j++) PP(ii,j,(ii-16)/9+16+col*32);}

void Clrline(int ii)
      {	for(j=upper;j<lower;j++) PP(ii,j,0);}

void Right()
{  delay(del);// traceWait();
  if(zeiger<304-width)
      { zeiger++; Setline(zeiger+width);Clrline(zeiger-width-1);}
}
void Left()
{ delay(del); //traceWait();
  if(zeiger>16+width)
       { zeiger--;Setline(zeiger-width);Clrline(zeiger+width+1);}
}

void SetAllColors(char (*pl)[3])
{
	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1012;
	_BX=0;
	_CX=256;
	geninterrupt(0x10);
}

void GetAllColors(char (*pl)[3]) // loads standard colors to palette ?
{
	traceWait; //   doesn't do anything ??
	_ES=FP_SEG(pl);
	_DX=FP_OFF(pl);
	_AX=0x1017;
	_BX=0;
	_CX=256;
	geninterrupt(0x10);
}

void p(int jc,char* pt)  {gotoxy(1,jc); cputs(pt);}

void fout(long zz)    // cout << formatted number, 8 spaces
{  int kk= 8;
   long zzz = labs(zz);  // long abs
   while(zzz>0) {zzz = zzz/10; kk--;}
   if(zz<0) kk-- ;
   while(kk>0) { cout << " "; kk-- ;}
   cout << zz;
}
// .............................................................

void main()
{
	    unsigned long Q = 0;
	    unsigned long lock = (9+16*(4+16*(7+2*16)));
	    lock = 6+16*lock;
	    lock = 3+16*lock;
	    lock = 8+16*lock;
	    lock = 5+16*lock;  // lock = HEX{27496385}
test = 0;
	randomize();

//......................................................
hasfile = 0;      // Test if data file is present, set hasfile = 0/1
if(!access(datpsi,0)) hasfile=1;// needs io.h  (Compl.Refer.pg346)
			// access(. ,0) = 0 if file is present !
long ofdat = 0, ofin = 0;
int anf = 0, ende = 0;
//.................... generate file movedat.psi if appropriate........
if(!hasfile && !access(dat,0))
  {      fpdat = fopen(datpsi,"wb");	//movedat.psi
	 fptr  = fopen(dat,"rb+");       //movedat
	 // needs BINARY file to make ftell(fpdat) work right
	 fprnt = fopen(druck,"w");      //prntmove
	 fseek(fptr,ofin,0);
	 fseek(fpdat,ofdat,0);
     while(!feof(fptr) )
	    {  if(!feof(fptr)) {ch = getc(fptr); }
	      if(iszahl(ch)) { Q = Q<<4; Q += makezahl(ch);} else Q=0;
	      if(Q == lock) {ende=1;break;}
	    }
  if(ende)
   { ofin = ftell(fptr)-8; fseek(fptr,ofin,0);
		// sets file pos.indicater to start of code 274..
     for(i=0;i<16;i++){ch=getc(fptr);putc(ch,fpdat);typus[i]=ch;}
     for(i=0;i<2;i++) {ch=Getc(fptr);putc(ch,fpdat);}
     ch0 = '0'; for(i=0;i<2;i++) putc(ch0,fpdat);
     fprintf(fprnt,"%s",typus);  fclose(fprnt);
     i=0;
     while(!feof(fptr))
	    {  if(!feof(fptr)) ch = getc(fptr);
	       if(iszahl(ch))
		{i=(i+1)%8; putc(ch,fpdat);
		 if(i==0){putc(ch0,fpdat);putc(ch0,fpdat);}}
	    }
     // disable the file move-dat by changing the code 27496385 -> 07496..
     fseek(fptr,ofin,0); ch = '0'; putc(ch,fptr);
     fclose(fptr);fclose(fpdat);
     hasfile = 1;
   }
  }

if(hasfile)
{	fpdat = fopen(datpsi,"r+");
	int ofdat = 16; fseek(fpdat,ofdat,0);
	Anzahl = holint();
	unit = holint();
	runsleft = Anzahl - unit; // if full then unit = Anzahl
	if(runsleft)
	  { ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1; // SdM.0 for optional later assignment
			RnM0 = SdM | 0x0300;
	   }
	 fclose(fpdat);
}



SdS = random(256);SdM = random(256);
RnS = (SdS << 1) + 1; RnM = SdM + 0x0300;

//............... First Page at Power-Up ............................
clrscr();
//for(q=0;q<16;q++) {textcolor(q);gotoxy(20+2*q,1);cputs("X");}
textcolor(13);
p(2,"                            Experiment:  MOVE");
for(j=0;j<32;j++) {q = j % 8 + 8;textcolor(q);gotoxy(22+j,4);cputs(".");}
textcolor(11);
p(7,"                              Helmut Schmidt");
p(8,"                                P.O.Box 296");
p(9,"                              Mora, NM 87732");
p(10,"                              (505) 387-2184");
p(11,"                            psischmidt@aol.com");
textcolor(10);
p(15,"          See the File README for General Information on the
Experiments");
p(17,"          Read File Move.Txt for Details on this Experiment MOVE");
p(19,"             Turn the Printer on if you want a Printed Record");
textcolor(11);
if(!hasfile)
{ p(21,"                    No Data Files: Only Explore-Runs are
available.");}
else { p(21,"                 Number of still Available Record-Runs :");
       gotoxy(60,21);cputs(itoa(runsleft,Ito,10));}
textcolor(14);
p(24," Press X to EXIT Program.                       Press any Key to
Continue");
ch0 = getch(); if(ch0=='X' || ch0=='x') exit(0);
//..................................................................



Anfang:
if(jmp) goto Weiter;

clrscr();
// for(int n=0;n<16;n++) {textcolor(n);gotoxy(n,2);cputs("X");}
textcolor(13);
p(1,"                      Program: Move");
textcolor(10);
p(3,"You will see a colored large block moving randomly right and left.");
p(4,"You try to move the block to the right or left and to keep itF there.");
textcolor(13);
p(6,"You may select the following options:");
textcolor(14);
p(8,"Select the Goal, Right or Left Move by pressing G.   Goal :");
textcolor(13);gotoxy(54,8);cputs("G");textcolor(14);
p(10,"Select a speed by pressing 0,1,...9 (fastest)       Speed :");
textcolor(13);gotoxy(28,10);cputs("0,1,...9");textcolor(14);
p(12,"Select between the informal Explore-Mode and the");
p(13,"Record-Mode with recorded results by  pressing M      Mode:");
textcolor(13);gotoxy(55,13);cputs("M");textcolor(14);
p(15,"Select the color spectrum, green-blue, blue-red");
p(16,"or red-green by pressing C                          Colors:");
textcolor(13);gotoxy(53,16);cputs("C");textcolor(14);
p(18,"You may approach the task with different mental");
p(19,"Attitudes. Select what fits best by pressing A    Attitude:");
textcolor(13);gotoxy(51,19);cputs("A");
textcolor(13);
p(21,"Press ENTER to get the Start Display. Then Press ENTER again.");
textcolor(10);
p(22,"                    Press X to exit the program.");
textcolor(15);
p(24,"  A Explore-Run may be interrupted by pressing ENTER.");
p(25,"  A Record-Run cannot be interrupted.");
textcolor(10);
gotoxy(60,25);cputs("Record-Runs left:");
gotoxy(78,25); cputs(itoa(runsleft,Ito,10));

textcolor(13);
gotoxy(62,19);cputs(&ListA[attitude][0]);
gotoxy(62,16);cputs(&List[col][0]);
gotoxy(62,13); if(test) cputs("Record-Run "); else cputs("Explore-Run");
gotoxy(62,8); if(goal) cputs("Move to Right");else cputs("Move to Left ");
gotoxy(62,10);cputs(itoa(Speed,Ito,10));

for(;;) {  while(!kbhit()) Shift(); ch = getch();
	   if(ch==13) break;	 // ENTER
	   if(ch=='X'||ch=='x') {GrClose(); exit(0);}
	   if(ch=='M'||ch=='m') test = 1-test;
	   if(ch=='G'||ch=='g') goal = 1 - goal;
	   if(ch=='C'||ch=='c') col++; col = col % 3;
	   if(ch=='A'||ch=='a') attitude++; attitude = attitude % 4;
	   if((ch>47) && (ch < 59)) Speed = ch - 48;
  gotoxy(62,19);cputs(&ListA[attitude][0]);
  gotoxy(62,16);cputs(&List[col][0]);
  gotoxy(62,13); if(test) cputs("Record-Run "); else cputs("Explore-Run");
  gotoxy(62,8); if(goal) cputs("Move to Right");else cputs("Move to Left ");
  gotoxy(62,10);cputs(itoa(Speed,Ito,10));
	}

del = Del[Speed];
Weiter: rep = 0;
Weiter2:
	GrInit();
	GetAllColors(pl);
	pl[3][0]=0; pl[3][1]=63; pl[3][2]=0; // --------- target arrow
	pl[4][0]=0; pl[4][1]=0; pl[4][2]=0; //        >      "
	pl[5][0]=0; pl[5][1]=0; pl[5][2]=0; //        <      "
	pl[6][0]=40;pl[6][1]=40;pl[6][2]=40;// color6 = white
	pl[8][0]=20; pl[8][1]=20 ; pl[8][2]=63; // blue
	pl[9][0]=63 ; pl[9][1]=20; pl[9][2]=0; // red
	pl[10][0]=0 ; pl[10][1]=63 ; pl[10][2]=0;// green
	pl[11][0]=0 ; pl[11][1]=0 ; pl[11][2]=0; //center target color
	pl[7][0]=60; pl[7][1]=43; pl[7][2]=0; // yellow-gold text <<---

	long int B = 16;// Define colors
	for(j=0;j<16;j++){pl[B+j][0]=60;pl[B+j][1]=4*j;pl[B+j][2]=0;}
	B=32;for(j=0;j<16;j++){pl[B+j][0]=60-4*j;pl[B+j][1]=60;pl[B+j][2]=0;}
	B=48;for(j=0;j<16;j++){pl[B+j][0]=0;pl[B+j][1]=60;pl[B+j][2]=4*j;}
	B=64;for(j=0;j<16;j++){pl[B+j][0]=0;pl[B+j][1]=60-4*j;pl[B+j][2]=60;}
	B=80;for(j=0;j<16;j++){pl[B+j][0]=4*j;pl[B+j][1]=0;pl[B+j][2]=60;}
	B=96;for(j=0;j<16;j++){pl[B+j][0]=60;pl[B+j][1]=0;pl[B+j][2]=60-4*j;}
	SetAllColors(pl);

struct tm *ptr;			// print data and time
time_t lt;
lt = time(NULL);
ptr = localtime(&lt);

zeiger = 160;
int shft = 32*col;
for(i=16;i<304;i++)         //  draw top color band
for(j=10;j<30;j++)
      {  PP(i,j,(i-16)/9 + 16 + shft);}
for(i=zeiger-width;i<(zeiger+width+1);i++)   // draw rectangle
{ for(j=upper;j<lower;j++)
      {  PP(i,j,(i-16)/9 + 16 + shft);}
  for(j=upper-10;j<upper-7;j++)
      {  PP(i,j,(i-16)/9 + 16 + shft);}
}
	 int low = lower+10;
	 int colC=col+8;                       // Draw target arrow
	 for(j=140;j<183;j++) PP(j,4+low,colC);
	 int colR=4;
	 for(k=0;k<2;k++)
       {
PP(180+k,3+low,colR);PP(180+k,5+low,colR);PP(179+k,2+low,colR);PP(179+k,6+low,
colR);
	 PP(178+k,1+low,colR);PP(178+k,7+low,colR);}
	 int colL=5;
	 for(k=0;k<2;k++)
       {
PP(141+k,3+low,colL);PP(141+k,5+low,colL);PP(142+k,2+low,colL);PP(142+k,6+low,
colL);
	 PP(143+k,1+low,colL);PP(143+k,7+low,colL);}

	for(i=0;i<3;i++) { pl[4][i]=0;pl[5][i]=0;}
	if(goal) for(i=0;i<3;i++) pl[4][i]=pl[colC][i];
	   else  for(i=0;i<3;i++) pl[5][i]=pl[colC][i];
	SetAllColors(pl);
if(rep) goto Loop2;
for(j=1;j<20;j++) cout << endl;
cout << "Pressing G still changes the Goal";
cout << endl<< endl << endl;
cout << "Pressing ENTER Starts Run";
rep = 1;

Loop:
while(!kbhit()) Shift(); ch = getch();
if(ch=='G'||ch=='g')
{       goal = 1 - goal;
	for(i=0;i<3;i++) { pl[4][i]=0;pl[5][i]=0;}
	if(goal) for(i=0;i<3;i++) pl[4][i]=pl[colC][i];
	   else  for(i=0;i<3;i++) pl[5][i]=pl[colC][i];
	 SetAllColors(pl);goto Loop;
}
goto Weiter2;
Loop2:
// .................... Display Running .........................
ScoreR = ScoreL = 0;
if(!runsleft) test = 0;
int zeig = 0;
long int S = 0;
if(test) {RnS=RnS0;RnM=RnM0;}
step0=0;  // interrupt ?
for(step=0;step<Steps;step++)		// Steps = 400
{  h = 160 + (36*step)/100;  // top line expands,++ Run %
	PP(h,4,(h-16)/9 + 16 + shft);	// shft = 32*col; col = 0,1,2
   h = 160 - (36*step)/100;
	PP(h,4,(h-16)/9 + 16 + shft);

	if(kbhit()) {step=Steps;step0=1;delay(100);}
	if(GetBit()>0) {traceWait();Left();Left();Left();Left();
	       Left();Left();Left();Left();ScoreL++;zeig++; S += zeig; }
	else {traceWait(), Right();Right();Right();Right();
		Right();Right();Right();Right();ScoreR++;zeig--; S += zeig;}
 }
// ......................End of Display ...............................

if(kbhit()) getch();
for(j=1;j<14;j++) cout << endl;
//cout << ScoreL << "                              " << ScoreR << endl;
cout << endl ;
score = ScoreL-ScoreR; if(goal) {score=-score; S = -S;}
double dd = (100.0 * score)/sqrt(Steps); score = (int) dd;
double ee = (100.0 * S)/sigma;int SS = (int) ee;
att = attitude;
if(step0){att=4;score=0;SS=0;}  // if Explore run was interrupted
if(!step0) cout << "  Score = " << SS <<  endl;
cout << "  ------------ " << endl << endl << endl;
cout << "    For Same Run press the Space Bar" << endl << endl;
cout << "    For New Run press ENTER" << endl<< endl;
cout << "    To EXIT Program press X";

/*	N = Steps = 400.    e1, e2,.. eN = +/- 1
	S1 = e1, S2 = e1+e2, S3 = e1+e2+e3,  SN = e1+e2+..+eN
	S = S1+S2+..+SN = N*e1+(N-1)*e2+(N-2)*e3+...+eN
	AV{S*S} = 1+2*2+3*3+4*4+...+N*N = (N+1)*(2*N+1)*N/6
	sigma = 4627.5
*/
if(goal){int tmp = ScoreR;ScoreR=ScoreL;ScoreL=tmp;}
getzeit();

asm {   mov ah,2		// Check if Printer is operating
	mov dx,0                // Set hasprint = 1 or 0
	int 17h
	mov hasprint,ax  }

hasprint = hasprint/256;  // 10010000 with printer, 11001000 without
	 // bit 6 : acknowledge, bit 4 : printer selected, bit 3 : I/O error
hasprint = hasprint & 0x58;
if(hasprint == 16) hasprint=1; else hasprint=0; // 1/0 for yes/no printer

	if(test)
	     {  unit++; runsleft = Anzahl - unit;
		fpdat = fopen(datpsi,"r+");
		ofdat = 18; fseek(fpdat,ofdat,0);
		int xxx = unit >> 4;
		ch = makehex(xxx); putc(ch,fpdat);
		ch = makehex(unit); putc(ch,fpdat);

		ofdat = 20+10*unit-2;  	// write info-byte. unit = 1,2,..
		fseek(fpdat,ofdat,0);
		j = Speed*16 + att + 1;
		xxx = j >> 4;
		ch = makehex(xxx); putc(ch,fpdat);
		ch = makehex(j); putc(ch,fpdat);

		if(unit<Anzahl)
		{
		ofdat = 20+ 10*unit; fseek(fpdat,ofdat,0);
			SdS = holint();
			SdS = SdS << 8;
			SdS += holint();
			SdM = holint();
			SdM = SdM << 8;
			SdM += holint();
			RnS0 = (SdS << 1) + 1;
			assign = SdM & 1;
			SdM = SdM | 1; // SdM.0 for optional later assignment
		 }	RnM0 = SdM | 0x0300;
		 fclose(fpdat);
	     }

if(test)
  {		fptr = fopen("prntmove.psi","a"); // open for append text
    fprintf(fptr,"\n\n\r%s%4d,%s%2d%s%s%s", " Score =",SS,
	     "  Speed = ",Speed,"  ",&ListA[att][0], zeit);
	fprintf(fptr,"%s%3d","  Move # ",unit-1);
	fclose(fptr);
   }

if(hasprint)
{
 fprintf(stdprn,"\n\n\r%s%4d,%s%2d,%s%s%s%s", " Score = ",SS,
	"  Speed = ",Speed,"  ",&ListA[att][0], zeit,"  Mov# ");
 if(test) fprintf(stdprn,"%3d",unit-1);
}

if(kbhit())getch();
ch = getch();
GrClose();
if(ch==13) { jmp = 0; goto Anfang;}   // ENTER
if(ch==32) { jmp = 1; goto Anfang;}   // SPACE BAR
}

